#!/bin/sh
#
# wrapper script to handle subscriptions and unsubscriptions from ezmlm mailing
# lists.  this script should be run as root.  it would usually _be_ run as
# root, as that was the purpose of creating this wrapper in the first place.

LIST_USER=mlists
LIST_DIR=/var/mlists	# generally the home dir of LIST_USER
LIST_BIN=/usr/ars/bin	# dir of ezmlm bins

CHSTUFF=/usr/sbin/chstuff

usage() {
	echo "usage: $0 <sub|unsub|list> <mlist> [user@domain] ..."
	echo "       at least one address is required for sub and unsub"
	exit 1
}

[ $# -lt 2 ] && usage

if [ "$1" = "sub" -o "$1" = "unsub" -o "$1" = "list" ]; then
	EZMLM="$LIST_BIN/ezmlm-$1"
else
	usage
fi

MLIST_DIR="$LIST_DIR/$2"

if [ "$3" != "" ]; then
	# kill the first two args, as we won't need them here
	# further anyway
	shift
	shift
	MLIST_ADDRS="$*"
elif [ "$1" != "list" ]; then
	usage
fi

CMD="$EZMLM $MLIST_DIR"
[ "$MLIST_ADDRS" != "" ] && CMD="$CMD $MLIST_ADDRS"

$CHSTUFF -u $LIST_USER -- $CMD
exit $?

