#!/bin/bash
# uses bash for RANDOM/SECONDS and test -e
#
# create a new mailing list
#
# uses stock ezmlm

LIST_USER=mlists
LIST_HOST=phri.nyu.edu

LIST_DIR=/var/mlists
ALIAS_DIR=/var/qmail/alias
LIST_BIN=/usr/ars/bin
BOTTOM=text/bottom

CHSTUFF=/usr/sbin/chstuff

if [ $# -ne 1 ]; then
	echo "Usage: $0 <list_to_create>"
	exit 1;
fi

LIST="$1"

ULIST="$LIST_USER-$LIST"

# usage: check_exist -f /etc/bleh
check_exist() {
	TYPE=$1
	FILE=$2

	if [ $TYPE "$FILE" ]; then
		echo "$FILE already exists" 1>&2
		exit 1
	fi
}

check_exist -d "$LIST_DIR/$LIST"
check_exist -f "$LIST_DIR/.qmail-$LIST"
check_exist -f "$ALIAS_DIR/.qmail-$LIST"

$CHSTUFF -u $LIST_USER -- \
	"$LIST_BIN/ezmlm-make" "$LIST_DIR/$LIST" "$LIST_DIR/.qmail-$LIST" \
	"$LIST_USER-$LIST" "$LIST_HOST" || exit 1

echo "|preline qmail-inject $LIST_USER-\$EXT" > "$ALIAS_DIR/.qmail-$LIST"
echo "|preline qmail-inject $LIST_USER-\$EXT" > "$ALIAS_DIR/.qmail-$LIST-default"
echo "|preline qmail-inject $LIST_USER-\$EXT" > "$ALIAS_DIR/.qmail-$LIST-owner"
echo "|preline qmail-inject $LIST_USER-\$EXT" > "$ALIAS_DIR/.qmail-$LIST-return-default"

BOT="$LIST_DIR/$LIST/$BOTTOM"
TMP="$BOT.tmp.$SECONDS.$RANDOM"
if [ -f "$BOT" ]; then
	if [ -e "$TMP" ]; then
		echo "somehow, $TMP exists.  $BOT NOT changed."
	else
		cat "$BOT" | sed "s/$LIST_USER-$LIST/$LIST/g" >"$TMP"
		rm -f $BOT
		mv $TMP $BOT
	fi
fi

